//------------------------------------------------------------------------------
//
// PROJECT : OpenGL
//
// FILE    : COpenGL.h
//
// VERSION : 1.2
//
//
//------------------------------------------------------------------------------
//
// Inhalt: Deklaration der Klasse COpenGL
//
//------------------------------------------------------------------------------
//
//

#ifndef COPENGL
#define COPENGL

#include <stdlib.h>
#include <CVector3T.h>
#include <CGL_Camera.h>

enum
{
	EGL_FULLSCREEN = 1,
	EGL_DEPTH      = 2,
	EGL_DOUBLE     = 4,
	EGL_RGBA       = 8
};

enum
{
	EDRAWMODE_ENVMAP    = 1,
	EDRAWMODE_ANAGLYPH  = 2
};

class CGL_Mouse : public CVector3<int>
{
	public:

		CGL_Mouse()
		{
			mState[0] = GLUT_UP;
			mState[1] = GLUT_UP;
			mState[2] = GLUT_UP;
			mState[3] = GLUT_UP;
		}

		int mButton;
		int mState[4];
};


class COpenGL
{
  public:

		bool InitWindowGLUT(int argc, char** argv, const char* WindowName, int width, int height, unsigned int mode);
    void Action(void);
    void MouseButtonAction(void);
    void MouseMotionAction(void);
    void KeyboardAction(unsigned char key);
    void StartModelView(void);
    void StartProjectionView(void);
		void SaveGLStrings(char* filename);
		void InitGLUTCallback(int fq);
		unsigned int* CreateSplitTextures(string& TextureFile, int XPatches, int YPatches);
		void   SetViewport(int w, int h);
		void   ViewportAction(int w, int h);
		void  DrawAnaglyphMode(void);
		void  CheckError(void);




		int             mActionFrequency;
		CGL_Mouse       mMouse;
		CVector3<float> mLightPosition;
		CGL_Camera      mCamera;
		bool            mAnaglyph;
		int             mDrawmode;

  protected:

		int             mWindowHandle;
    int             mWidth;
    int             mHeight;
    float           mAspect;



    void   SetupLighting(void);
		void   SetPixelFormatDescriptorBitmap(void);


};

#endif
