
#ifndef CGLAPPLICATION
#define CGLAPPLICATION

#include <vector>
#include <list>
#include "CBlub.h"

class CGLApplication
{
	public:

		CGLApplication();

		const char* Name()    { return "3dlviewer"; }
		const char* Version() { return "1.1"; }

		void InitApplication(int argc, char* argv[]);
		void Draw3DObjects(void);
		void Draw2DObjects(void);
		void ManageInterface(CGL_Mouse* Mouse);
		void LeftMouseButtonDown(void);
		void RightMouseButtonDown(void);
		void MouseWheel(int d);

		void MouseMotionLeft(int x, int y);
		void MouseMotionRight(int x, int y);

		void KeyboardAction(unsigned char key);
		void SetResolution(int w, int h);

		bool                  mFullscreen;

	protected:

		void Zoom(float f);

		void DrawHeightField(int PsegS, int PsegT, std::list<CBlub>& Blub);
		void DrawHeightFieldColor(int PsegS, int PsegT, list<CBlub>& Blub);

    void NewBlub(void);
    void RunBlubs(void);



		COpenGL*              gOpenGL;
		CG3DGlobals*          gResGlobals;
		//CG3DReslistInterface* gG3Dinterface;
		//SG3DcomData           gSlider;
		float                 mScale;
		bool                  mInitFlag;
		bool									mAutoScale;
		bool                  mAutoRotate;
		bool                  mShowInterface;

		bool                  mXrotFlag;
		bool                  mYrotFlag;
		bool                  mZrotFlag;
		float                 mXrotVal;
		float                 mYrotVal;
		float                 mZrotVal;
		float mXrotAuto, mYrotAuto, mZrotAuto;
		const char*           mFilemap;
		bool                  mAutoBlubs;
		int                   mFieldRes;
		int                   mPolygonMode;
		list<CBlub>           mBlubVec;

};

#endif

