


static inline int pk(int x, int y, int w) { return (y * w) + x; }

static inline int align(int k, int d)
{
  if (k  < 0) k += d;
  if (k >= d) k -= d;
  return k;
}

struct SKotab
{
  int x, y;
};

template <typename T>
void CHeightField<T>::MakeNormal(int x, int y, CVector3<float>* norm)
{
	SKotab otab[] =
	{
		{ -1,  -1 },
		{  0,  -1 },
		{  1,  -1 },

		{  1,   0 },
		{  1,   1 },
		{  0,   1 },

		{ -1,   1 },
		{ -1,   0 },
		{ -1,  -1 }
	};

  CVector3<float>* v0 = mVertex + (y * mWidth) + x;
  CVector3<float>  vlast;


  norm->Set(0,0,0);

  for (int j = 0; j < 9; j++)
  {
  	int xa = otab[j].x;
  	int ya = otab[j].y;

		int vix = align(x + xa, mWidth);
		int viy = align(y + ya, mHeight);

		CVector3<T> v1 = *v0 - mVertex[pk(vix, viy, mWidth)];

	  if (j > 0)
	  {
	  	CVector3<T> Norm1;
	  	Norm1.NormalVector(&vlast, &v1);
	  	*norm += Norm1;
	  }
	  vlast = v1;

	}
	//cout << "norm1=" << norm->x << ',' << norm->y << ',' << norm->z << endl;

	norm->Normalize();

	//cout << "norm2=" << norm->x << ',' << norm->y << ',' << norm->z << endl;
}

template <typename T>
void CHeightField<T>::MakeNormals()
{
	for (int y = 0; y < mHeight; y++)
	{
		for (int x = 0; x < mWidth; x++)
		{
			MakeNormal(x, y, mNormals + pk(x, y, mWidth));
		}
	}
}
